﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace AgApp
{
	public class MyToolBar : RadToolBar
	{
		public override void OnApplyTemplate()
		{
			this.ItemContainerStyleSelector = new MyStyleSelector(this.ItemContainerStyleSelector);
			base.OnApplyTemplate();
		}
	}

	public class MyStyleSelector : StyleSelector
	{
		private ToolBarContainerStyleSelector originalStyleSelector = null;

		/// <summary>
		/// Initializes a new instance of the ToolBarContainerStyleSelector class.
		/// </summary>
		public MyStyleSelector(StyleSelector originalStyleSelector)
		{
			this.originalStyleSelector = originalStyleSelector as ToolBarContainerStyleSelector;
		}

		public override Style SelectStyle(object item, DependencyObject container)
		{
			if (originalStyleSelector != null)
			{
				var typeName = item.GetType().Name;
				if ("MyButton" == typeName)
				{
					Style style = this.GetStyle("Button");
					return style;
				}
				return originalStyleSelector.SelectStyle(item, container);
			}
			return null;
		}

		internal Style GetStyle(string typeName)
		{
			if (originalStyleSelector != null)
			{
				foreach (var contentItem in this.originalStyleSelector.ContainerStyles)
				{
					ToolBarContainerStyle containerStyle = contentItem as ToolBarContainerStyle;
					if (containerStyle != null && containerStyle.TypeName == typeName)
					{
						return containerStyle.ContainerStyle;
					}
				}
			}
			return null;
		}
	}
}
